--------------------------------------------------------------------------------
-- SubModule AD_Converter
-- Created   24.06.2005 14:57:33
--------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

entity AD_Converter is port
   (
     CLK          : in    std_logic;
     CLR          : in    std_logic;
     DATA_ADC     : in    std_logic;
     GATE         : in    std_logic;
     CS_ADC       : out   std_logic;
     OUTPUT       : out   std_logic
   );
end AD_Converter;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
architecture Structure of AD_Converter is


   -- Signal Declarations
   signal S_REGA              : std_logic_vector (17 downto 0);
   signal S_SPEICHER_A        : std_logic_vector (11 downto 0);
   signal S_SHIFT_SPEICHER_A  : std_logic;

begin


process (CLR,CLK,GATE)

begin
   if (CLR = '1' or GATE = '0') then
      CS_ADC <= '1';
   elsif (CLK'event and CLK = '1') then
      CS_ADC <= S_REGA(0);
   end if;
end process;



process (CLR,CLK,GATE)

begin
   if (CLR = '1' or GATE = '0') then
      S_SHIFT_SPEICHER_A <= '0';
   elsif (CLK'event and CLK = '1') then
      if(S_REGA(5) = '1' or S_REGA(17) = '1')then
         S_SHIFT_SPEICHER_A <= NOT S_SHIFT_SPEICHER_A;
      end if;
   end if;
end process;



process (CLR,CLK,GATE)

begin


   if (CLR = '1' or GATE = '0') then
      S_SPEICHER_A <= (others => '0');
   elsif (CLK'event and CLK = '0') then
      if(S_SHIFT_SPEICHER_A = '1')then
          S_SPEICHER_A <= S_SPEICHER_A(10 downto 0) & DATA_ADC;
      end if;
   end if;
end process;



process (CLR,CLK,GATE)

begin
   if (CLR = '1' or GATE = '0') then
      OUTPUT <= '0';
   elsif (CLK'event and CLK = '1') then
      if(S_REGA(17) = '1')then
         OUTPUT <= S_SPEICHER_A(2);
      end if;
   end if;
end process;



process (CLR,CLK,GATE)

begin
   if (CLR = '1') then
      S_REGA <= "000000000000000001";
   elsif (CLK'event and CLK = '0') then
      S_REGA <=  S_REGA(16 downto 0) & S_REGA(17); -- schieben
   end if;
end process;

end Structure;
--------------------------------------------------------------------------------
